Part ShapeFromMesh
|
Menu location |
---|
Part → Create shape from mesh... |
Workbenches |
Part |
Default shortcut |
None |
Introduced in version |
- |
See also |
Part ConvertToSolid, Part RefineShape, Part PointsFromMesh |
Introduction
The Part ShapeFromMesh command creates a shape from a mesh object. Mesh objects have limited editing capabilities in FreeCAD, converting them to shapes will allow their use with many more boolean and modification tools.
The inverse operation is Mesh FromPartShape from the
Mesh Workbench.
Usage
- Select the mesh object in the tree view.
- Go to the menu, Part →
Create shape from mesh.
- A popup-menu will ask for the tolerance for sewing shape; the default value is
0.1
. - A shape from the mesh object is created as a separate new object.
Analyzing and repairing of the mesh, if needed, should be done manually before launching ShapeFromMesh. Appropriate tools for this task are available in the
Mesh Workbench.
After creation of a Shape, it may be useful to use Convert to solid (necessary for boolean operations) and
Refine shape.
Links
- Edit STL Files In FreeCAD video by AllVisuals4U.
Scripting
Creating a Shape from a Mesh can be done by using the makeShapeFromMesh
method from a Part TopoShape; you need to specify the source mesh and tolerance, and assign the result to a new Part Feature object.
Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.
import FreeCAD as App
import Part
doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()
solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)
solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()
- Primitives: Box, Cylinder, Sphere, Cone, Torus, Tube, Create primitives, Shape builder
- Creation and modification: Extrude, Revolve, Mirror, Fillet, Chamfer, Make face from wires, Ruled Surface, Loft, Sweep, Section, Cross sections, 3D Offset, 2D Offset, Thickness, Projection on surface, Attachment
- Boolean: Make compound, Explode Compound, Compound Filter, Boolean, Cut, Fuse, Common, Connect, Embed, Cutout, Boolean fragments, Slice apart, Slice, XOR
- Measure: Measure Linear, Measure Angular, Measure Refresh, Clear All, Toggle All, Toggle 3D, Toggle Delta

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Arch, Draft, FEM, Inspection, Mesh, OpenSCAD, Part, PartDesign, Path, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Start, Surface, TechDraw, Test Framework, Web
- Hubs: User hub, Power users hub, Developer hub